#ifndef AMSMF_INPUT_BUFFER_H_
#define AMSMF_INPUT_BUFFER_H_

#include <amt/Defines.h>
#include <amsmf/Types.h>
#include <amsmf/Assert.h>

namespace AMSMF
{

class InputBuffer
{
	const U8 *m_buffer;
	U32 m_length;
public:
	InputBuffer() : m_buffer(NULL), m_length(0) { }
	InputBuffer(const U8 *b, U32 l) : m_buffer(b), m_length(l) { }
	AMT_ACSOR_R(const U8 *, buffer);
	AMT_ACSOR_R(U32, length);
	const U8 &operator [] (U32 ofs) const { return m_buffer[ofs]; }
	void cut_front(U32 len)
	{
		AMSMF_ASSERT_U_("forward", m_length >= len);
		m_buffer += len;
		m_length -= len;
	}
	U8 get_byte()
	{
		AMSMF_ASSERT_U_("get_byte", m_length > 0);
		m_length--;
		return *m_buffer++;
	}
	bool is_empty() const { return m_length == 0; }
};

} // AMSMF

#endif
