#include <amt/LexCast.h>

namespace AMT
{

template <>
long lex_cast(const char *str, int aux)
{
	long ret;
	char *endptr;

	ret = strtol(str, &endptr, aux);
	if (*endptr)
		throw Ex::ParseError();
	return ret;
}

template <>
unsigned long lex_cast(const char *str, int aux)
{
	unsigned long ret;
	char *endptr;

	ret = strtoul(str, &endptr, aux);
	if (*endptr)
		throw Ex::ParseError();
	return ret;
}

template <>
double lex_cast(const char *str)
{
	double ret;
	char *endptr;

	ret = strtod(str, &endptr);
	if (*endptr)
		throw Ex::ParseError();
	return ret;
}

} // AMT
