//
//
//

#ifndef AMT_EXCEPTION_H_
#define AMT_EXCEPTION_H_

namespace AMT
{

namespace Ex
{

struct Base { };

struct TypeError : public Base { };
struct UnknownType : public TypeError { };
struct UnmatchedType : public TypeError { };

struct Assertion : public Base { };
struct Failure : public Assertion { };

struct DataError : public Base { };
struct ParseError : public DataError { };
struct IllegalVersion : public DataError { };
struct NotExist : public DataError { };
struct IllegalFormat : public DataError { };

struct SystemError : public Base { };
struct CannotOpenFile : public SystemError { };
struct CannotReadFile : public SystemError { };
struct CannotWriteFile : public SystemError { };
struct NoMemory : public SystemError { };
struct IllegalArgument : public SystemError { };

} // namespace Ex

} // namespace AMT

#endif
