#ifndef AMT_LEXCAST_H_
#define AMT_LEXCAST_H_

#include <amt/Defines.h>
#include <amt/Types.h>
#include <amt/Assert.h>
#include <string>

namespace AMT
{

template <typename T_> T_ lex_cast(const char *);
template <typename T_> T_ lex_cast(const std::string &s)
{ return lex_cast<T_>(s.c_str()); }
template <typename T_> T_ lex_cast(const char *, int);
template <typename T_> T_ lex_cast(const std::string &s, int aux)
{ return lex_cast<T_>(s.c_str(), aux); }

template <> long lex_cast(const char *, int);

template <> unsigned long lex_cast(const char *, int);

template <> inline long lex_cast(const char *str)
{ return lex_cast<long>(str, 0); }

template <> inline unsigned long lex_cast(const char *str)
{ return lex_cast<unsigned long>(str, 0); }

template <> double lex_cast(const char *);

} // AMT

#endif
