#ifndef AMT_LOCK_MANAGER_H_
#define AMT_LOCK_MANAGER_H_

#include <amt/Defines.h>
#include <amt/Types.h>
#include <amt/Assert.h>
#include <amt/ScopedLocker.h>

namespace AMT
{

namespace Locker
{

template <class Prim_>
class Manager
{
	AMT_NOCOPY(Manager);
public:
	Prim_ LockPrimitive;
private:
	mutable Prim_ m_locker;
public:
	AMT_MUTABLE_ACSOR(Prim_, locker);
	typedef Locker::Scoped<const Manager<Prim_> > ScopedLocker;
	Manager() { }
	~Manager() { }
};

}

}

#endif
