#ifndef AMT_ISOC_ENDIAN_SWAP_H_
#define AMT_ISOC_ENDIAN_SWAP_H_

#include <amt/Defines.h>
#include <amt/Types.h>

namespace AMT
{

namespace Endian
{

struct Swap_
{
	template <typename T> static T conv(T);
};

template <> inline U8 Swap_::conv(U8 v) { return v; }
template <> inline U16 Swap_::conv(U16 v)
{ return (v>>8) | (v<<8); }
template <> inline U32 Swap_::conv(U32 v)
{ return Swap_::conv((U16)(v>>16)) | ((U32)Swap_::conv((U16)v)<<16); }
template <> inline U64 Swap_::conv(U64 v)
{ return Swap_::conv((U32)(v>>32)) | ((U64)Swap_::conv((U32)v)<<32); }

}

}

#endif
