#ifndef AMT_NETBSD_ENDIAN_H_
#define AMT_NETBSD_ENDIAN_H_

#include <sys/endian.h>

namespace AMT
{

namespace Endian
{

template <> inline U8 Big::to(U8 v) { return v; }
template <> inline U16 Big::to(U16 v) { return htobe16(v); }
template <> inline U32 Big::to(U32 v) { return htobe32(v); }
template <> inline U64 Big::to(U64 v) { return htobe64(v); }
template <> inline U8 Big::from(U8 v) { return v; }
template <> inline U16 Big::from(U16 v) { return be16toh(v); }
template <> inline U32 Big::from(U32 v) { return be32toh(v); }
template <> inline U64 Big::from(U64 v) { return be64toh(v); }

template <> inline U8 Little::to(U8 v) { return v; }
template <> inline U16 Little::to(U16 v) { return htole16(v); }
template <> inline U32 Little::to(U32 v) { return htole32(v); }
template <> inline U64 Little::to(U64 v) { return htole64(v); }
template <> inline U8 Little::from(U8 v) { return v; }
template <> inline U16 Little::from(U16 v) { return le16toh(v); }
template <> inline U32 Little::from(U32 v) { return le32toh(v); }
template <> inline U64 Little::from(U64 v) { return le64toh(v); }

}

}

#endif
