#ifndef LIBVSQ_BPLIST_H_
#define LIBVSQ_BPLIST_H_

#include <libvsq/ClockList.h>
#include <libvsq/Database.h>
#include <string>

namespace LibVSQ
{

class BPList
{
	std::string m_name;
	ClockList<int> m_list;
public:
	typedef ClockList<int>::Pair Pair;
	BPList(const std::string &n) : m_name(n) { }
	AMT_ACSOR_R(std::string, name);
	int &insert(ClockLength pos) { return m_list.insert(pos); }
	int num_entries() const { return m_list.num_entries(); }
	Pair &operator [] (int idx) { return m_list[idx]; }
        const Pair &operator [] (int idx) const { return m_list[idx]; }
};

namespace BPLists
{

class Database : LibVSQ::Database<BPList>
{
	typedef LibVSQ::Database<BPList> Super_;
public:
	Database() { }
	~Database() { }
	using Super_::find;
	using Super_::num_entries;
	using Super_::operator [];
	BPList &insert(const std::string &n)
	{ BPList *l = new BPList(n); this->Super_::insert(n, l); return *l; }
};

} // BPLists

} // LibVSQ

#endif
