#ifndef LIBVSQ_DATABASE_H_
#define LIBVSQ_DATABASE_H_

#include <libvsq/Defines.h>
#include <libvsq/Types.h>
#include <libvsq/Assert.h>
#include <amt/ScopedPtr.h>
#include <string>

namespace LibVSQ
{

template <class Data_>
class Database
{
	AMT_DECL_INNER_FRIEND_CLASS(Impl_);
	AMT::Ptr::Scoped<Impl_> m_impl;
	Data_ &at_(int) const;
	Data_ &at__(int idx) const
	{
		LIBVSQ_ASSERT_U_("operator []",
				 idx >=0 && idx < this->num_entries());
		return this->at_(idx);
	}
public:
	Database();
	~Database();
	void insert(const std::string &n, Data_ * =NULL);
	int num_entries() const;
	Data_ &operator [] (int idx) { return this->at__(idx); }
	const Data_ &operator [] (int idx) const { return this->at__(idx); }
	int find_index(const std::string &) const;
	const Data_ &find(const std::string &) const;
	Data_ &find(const std::string &);
};

} // LibVSQ

#endif
