#ifndef LIBVSQ_EVENT_DATA_DB_H_
#define LIBVSQ_EVENT_DATA_DB_H_

#include <libvsq/Defines.h>
#include <libvsq/Types.h>
#include <libvsq/Assert.h>
#include <libvsq/Database.h>
#include <amt/ScopedPtr.h>
#include <string>

namespace LibVSQ
{

class EventData;

namespace EventDatas
{

class Entry
{
	std::string m_name;
	AMT::Ptr::Scoped<EventData> m_data;
public:
	Entry(const std::string &);
	~Entry();
	AMT_ACSOR_RW(std::string, name);
	const EventData &data() const { return *m_data; }
	void set_data(EventData *);
};

class Database : LibVSQ::Database<Entry>
{
	typedef LibVSQ::Database<Entry> Super_;
public:
	Database() { }
	~Database() { }
	using Super_::num_entries;
	using Super_::operator [];
	using Super_::find;
	using Super_::find_index;
	Entry &insert(const std::string &n)
	{ Entry *e = new Entry(n); this->Super_::insert(n, e); return *e; }
};

} // EventDatas

} // LibVSQ

#endif
