#ifndef LIBVSQ_KEY_DISPATCH_H_
#define LIBVSQ_KEY_DISPATCH_H_

#include <libvsq/Defines.h>
#include <libvsq/Types.h>
#include <libvsq/Assert.h>
#include <amt/ScopedPtr.h>

namespace LibVSQ
{

namespace KeyDispatchers
{

template <class Ctx_>
class Handler
{
public:
	typedef Ctx_ Context;
	typedef typename Ctx_::Key Key;
	typedef typename Ctx_::Arg Arg;
private:
	Key m_key;
public:
	virtual ~Handler() = 0;
	virtual void operator () (Context &, Key, Arg) const = 0;
	//
	Handler(Key k) : m_key(k) { }
	AMT_ACSOR_R(Key, key);
};
template <class Ctx_> Handler<Ctx_>::~Handler() { }

} // KeyDispatchers

template <class Handler_>
class KeyDispatcher
{
	AMT_EMBED_IMPL;
public:
	typedef Handler_ Handler;
	typedef typename Handler::Context Context;
	typedef typename Handler::Key Key;
	typedef typename Handler::Arg Arg;
	~KeyDispatcher();
	KeyDispatcher();
	void insert(const Handler &);
	void operator () (Context &, Key, Arg) const;
};

} // LibVSQ

#endif
