#include <libvsq/CSV.h>
#include <libvsq/Exception.h>
#include <amt/LexCast.h>
#include <string.h>

namespace LibVSQ
{

namespace
{

const char SEP = ',';
const char QUOTE = '\"';

} // <anon>

std::string
CSV::fetch()
{
	const char *head;

	if (m_str == NULL)
		throw Ex::NoMoreEntry();

	if (*m_str != QUOTE) {
		m_str = strchr(head = m_str, SEP);
		if (!m_str)
			return head;
		return std::string(head, m_str++);
	}

	std::string ret;

	do {
		m_str = strchr(head = m_str+1, QUOTE);
		if (m_str == NULL)
			throw Ex::IllegalCSVFormat();
		ret += std::string(head, m_str++);
	} while (*m_str == QUOTE && (ret += QUOTE, true));

	if (*m_str++ != SEP)
		throw Ex::IllegalCSVFormat();

	return ret;
}

double CSV::fetch_double() { return AMT::lex_cast<double>(this->fetch()); }

int CSV::fetch_int() { return (int)AMT::lex_cast<long>(this->fetch()); }

} // LibVSQ
