#include <libvsq/EventDataDB.h>
#include <libvsq/EventData.h>
#include <libvsq/Database.tcc>
#include <libvsq/Exception.h>

namespace LibVSQ
{

namespace EventDatas
{

Entry::Entry(const std::string &n) : m_name(n) { }
Entry::~Entry() { }

void
Entry::set_data(EventData *d)
{
	if (m_data.is_valid())
		throw Ex::DuplicatedEntry();
	m_data.reset(d);
}

} // EventDatas

template class Database<EventDatas::Entry>;

} // LibVSQ
