#include <libvsq/ReadSectBPList.h>
#include <libvsq/ReadSection.tcc>
#include <libvsq/Track.h>
#include <libvsq/BPList.h>
#include <amt/LexCast.h>

namespace LibVSQ
{

class ReadSectBPList_ : public ReadSection
{
	BPList &m_list;
public:
	ReadSectBPList_(Track &tr, const char *sect)
		: m_list(tr.bplists().insert(sect))
	{ }
	void operator () (const char *key, const char *val)
	{
		ClockLength pos =
		    (ClockLength)AMT::lex_cast<unsigned long>(key);
		int num = (int)AMT::lex_cast<long>(val);
		m_list.insert(pos) = num;
	}
	void check_complete() const { }
};

template class ReadSectionFactoryTmpl<ReadSectBPList_>;

} // LibVSQ
