#include <libvsq/ReadSectCommon.h>
#include <libvsq/ReadSection.tcc>
#include <libvsq/Track.h>
#include <amt/LexCast.h>

namespace LibVSQ
{

namespace
{

#define ALL_SET(x)							      \
	x(T_PREMEASURE)

enum Tag
{
	T_PREMEASURE	= 0x00000001,
};

const U32 T_MANDATORY = LIBVSQ_RH_MAKE_MASK(ALL_SET);

class Context : public SimpleContextTmpl<Tracks::Master, Tag, T_MANDATORY>
{
	typedef SimpleContextTmpl<Tracks::Master, Tag, T_MANDATORY> Super_;
public:
	Context(Track &tr, Data &d) : Super_(tr, d) { }
	void check_complete() const
	{ this->Super_::check_complete_mandatory(); }
};

} // <anon>

#define RH_HANDLER(tag)		HandlerTmpl<Context, tag>

LIBVSQ_RH_DEF(T_PREMEASURE, "PreMeasure")
{ ctx.data().pre_measure() = (int)AMT::lex_cast<unsigned long>(a); }

LIBVSQ_RH_REGISTER(Context, ALL_SET);

class ReadSectMaster_ : public ReaderTmpl<Context>
{
	typedef ReaderTmpl<Context> Super_;
	static Tracks::Master &validate_master_(Track &tr)
	{
		if (tr.is_master_valid())
			throw Ex::DuplicatedEntry();
		return *(tr.master() = new Tracks::Master);
	}
public:
	ReadSectMaster_(Track &tr, const char *)
		: Super_(tr, ReadSectMaster_::validate_master_(tr))
	{ }
};

template class ReadSectionFactoryTmpl<ReadSectMaster_>;

} // LibVSQ
