#ifndef LIBVSQ_TIME_SIGN_MAP_H_
#define LIBVSQ_TIME_SIGN_MAP_H_

#include <libvsq/ClockList.h>

namespace LibVSQ
{

namespace TimeSignMaps
{

class TimeSign
{
	int m_numerator;
	int m_denominator;
public:
	TimeSign(int n =4, int d =4) : m_numerator(n), m_denominator(d) { }
	~TimeSign() { }
	AMT_ACSOR_RW(int, numerator);
	AMT_ACSOR_RW(int, denominator);
	void set(int n, int d) { m_numerator = n; m_denominator = d; }
};

} // TimeSignMaps

class TimeSignMap : public ClockList<TimeSignMaps::TimeSign>
{
	AMT_NOCOPY(TimeSignMap);
public:
	~TimeSignMap() {}
	TimeSignMap() { }
};

} // LibVSQ

#endif
