#include <libvsq/ParseVSQText.h>
#include <stdio.h>

class TestHooks : public LibVSQ::TextParser::Hooks
{
public:
	~TestHooks() { }
	TestHooks() { }
	void begin_section(const char *name)
	{
		printf("begin_section: [%s]\n", name);
	}
	void end_section(const char *name)
	{
		printf("end_section: [%s]\n", name);
	}
	void field(const char *sec, const char *key, const char *val)
	{
		printf("field[%s]: %s=%s\n", sec, key, val);
	}
};

int
main()
{
	TestHooks h;
	LibVSQ::TextParser p(h);
	FILE *fp = stdin;
	char *line;
	size_t len;

	do {
		line = fgetln(fp, &len);
	} while (p.parse(line, len));

	return 0;
}
