#include <libvsq/ReadSectBPList.h>
#include <libvsq/BPList.h>
#include <libvsq/Track.h>
#include <stdio.h>

int
main()
{
	LibVSQ::Track tr;
	LibVSQ::ReadSection::ScopedPtr rs;

	rs.reset(LibVSQ::ReadSectBPListFactory::get()(tr, "PitchBendBPList"));
	(*rs)("480", "8191");
	(*rs)("960", "-8192");
	(*rs)("0", "0");
	rs.reset();

	printf("result:\n");
	int n = tr.bplists().num_entries();
	printf("  num bplists: %d\n", n);
	for (int i=0; i<n; i++) {
		const LibVSQ::BPList &l = tr.bplists()[i];
		printf("  %d: [%s]\n", i, l.name().c_str());
		int m = l.num_entries();
		for (int j=0; j<m; j++) {
			const LibVSQ::BPList::Pair &p = l[j];
			printf("    %u=%d\n", p.pos(), p.entry());
		}
	}

	return 0;
}
