#include <libvsq/ReadSectCommon.h>
#include <libvsq/Track.h>
#include <stdio.h>

int
main()
{
	LibVSQ::Track tr;
	LibVSQ::ReadSection::ScopedPtr prsc(
		LibVSQ::ReadSectCommonFactory::get()(tr, "Common"));
	LibVSQ::ReadSection &rsc = *prsc;

	rsc("Version", "DSB301");
	rsc("Name", "Track1");
	rsc("Color", "181,162,123");
	rsc("DynamicsMode", "1");
	rsc("PlayMode", "1");
	prsc.reset();

	printf("result:\n");
	printf("  ver: %s\n", tr.common().version().c_str());
	printf("  name: %s\n", tr.common().name().c_str());
	printf("  color: %d,%d,%d\n", tr.common().color().r,
	       tr.common().color().g, tr.common().color().b);
	printf("  dm: %d\n", tr.common().dynamics_mode());
	printf("  pm: %d\n", tr.common().play_mode());

	return 0;
}
