#include <libvsq/Track.h>
#include <libvsq/EventDataDB.h>
#include <libvsq/EventList.h>
#include <libvsq/ReadSectEventList.h>

int
main()
{
	LibVSQ::Track tr;
	LibVSQ::ReadSection::ScopedPtr prsel(
		LibVSQ::ReadSectEventListFactory::get()(tr, "EventList"));
	LibVSQ::ReadSection &rsel = *prsel;

	rsel("0", "ID#0000");
	rsel("960", "ID#0001");
	rsel("1920", "ID#0002");
	rsel("4800", "EOS");
	prsel.reset();

	printf("result:\n");
	LibVSQ::EventList &l = tr.events();
	int nev = l.num_entries();
	for (int i=0; i<nev; i++) {
		printf("  %d: %s\n",
		       (int)l[i].pos(), l[i].entry()->name().c_str());
	}

	return 0;
}
