#include <libvsq/ReadSectMixer.h>
#include <libvsq/Track.h>
#include <libvsq/Mixer.h>
#include <stdio.h>

int
main()
{
	LibVSQ::Track tr;
	LibVSQ::ReadSection::ScopedPtr prsm(
		LibVSQ::ReadSectMixerFactory::get()(tr, "Mixer"));
	LibVSQ::ReadSection &rsm = *prsm;

	rsm("MasterFeder", "0");
	rsm("MasterPanpot", "0");
	rsm("MasterMute", "0");
	rsm("OutputMode", "2");
	rsm("Tracks", "2");
	rsm("Feder0", "0");
	rsm("Panpot0", "1");
	rsm("Mute0", "0");
	rsm("Solo0", "0");
	rsm("Feder1", "0");
	rsm("Panpot1", "-1");
	rsm("Mute1", "0");
	rsm("Solo1", "0");
	prsm.reset();

	printf("result:\n");
	printf("  mf: %d\n", tr.mixer()->master().fader());
	printf("  mp: %d\n", tr.mixer()->master().panpot());
	printf("  mm: %d\n", (int)tr.mixer()->master().mute());
	printf("  om: %d\n", (int)tr.mixer()->output_mode());
	int ntr = tr.mixer()->num_tracks();
	for (int i=0; i<ntr; i++) {
		printf("  tr: %d\n", i);
		const LibVSQ::Mixer::Param &p = (*tr.mixer())[i];
		printf("    f: %d\n", p.fader());
		printf("    p: %d\n", p.panpot());
		printf("    m: %d\n", (int)p.mute());
		printf("    s: %d\n", (int)p.solo());
	}

	return 0;
}
